import type { Placement } from 'popper.js';
import PropTypes from 'prop-types';
import { CSSProperties, ReactNode, Ref } from 'react';
export declare enum Align {
    JUSTIFY = "justify",
    LEFT = "left",
    RIGHT = "right"
}
export interface OverlayRenderProps {
    innerRef: Ref<any>;
    inputHeight: number;
    scheduleUpdate: () => void;
    style: CSSProperties;
}
export interface OverlayProps {
    align: Align;
    children: (props: OverlayRenderProps) => ReactNode;
    dropup: boolean;
    flip: boolean;
    isMenuShown: boolean;
    positionFixed: boolean;
    referenceElement?: HTMLElement;
}
export declare function getPlacement(props: Pick<OverlayProps, 'align' | 'dropup'>): Placement;
declare const Overlay: {
    ({ referenceElement, ...props }: OverlayProps): JSX.Element | null;
    propTypes: {
        align: PropTypes.Requireable<Align>;
        children: PropTypes.Validator<(...args: any[]) => any>;
        dropup: PropTypes.Requireable<boolean>;
        flip: PropTypes.Requireable<boolean>;
        isMenuShown: PropTypes.Requireable<boolean>;
        positionFixed: PropTypes.Requireable<boolean>;
        referenceElement: PropTypes.Requireable<Element>;
    };
    defaultProps: {
        align: Align;
        dropup: boolean;
        flip: boolean;
        isMenuShown: boolean;
        positionFixed: boolean;
    };
};
export default Overlay;
